'use strict';var yui;YUI.add('juju-gui',function(Y){yui=Y;var juju=Y.namespace('juju'),models=Y.namespace('juju.models'),views=Y.namespace('juju.views'),widgets=Y.namespace('juju.widgets'),d3=Y.namespace('d3');var components=window.juju.components;var extensions=[Y.juju.NSRouter,widgets.AutodeployExtension,Y.juju.Cookies,Y.juju.AppRenderer,Y.juju.GhostDeployer,Y.Event.EventTracker];var JujuGUI=Y.Base.create('juju-gui',Y.App,extensions,{defaultNamespace:'charmbrowser',views:{environment:{type:'juju.views.environment',preserve:true}},keybindings:{'A-s':{target:'#charm-search-field',focus:true,help:'Select the charm Search',label:'Alt + s'},'/':{target:'.header-search__input',focus:true,help:'Select the charm Search'},'S-/':{target:'#shortcut-help',toggle:true,callback:function callback(evt,target){if(target&&!target.getHTML().length){var bindings=[];Y.each(this.keybindings,function(v,k){if(v.help&&(v.condition===undefined||v.condition.call(this)===true)){bindings.push({key:k,label:v.label||k,help:v.help});}},this);ReactDOM.render(React.createElement(components.Shortcuts,{bindings:bindings,disableCookie:localStorage.getItem('disable-cookie'),disableAutoPlace:localStorage.getItem('disable-auto-place'),forceContainers:localStorage.getItem('force-containers')}),target.getDOMNode());target.one('#save-settings').on('click',function(ev){var fields=target.all('input');fields.each(function(node){if(node.get('type')==='checkbox'){if(node.get('checked')){localStorage.setItem(node.getAttribute('name'),true);}else{localStorage.removeItem(node.getAttribute('name'));}}else{localStorage.setItem(node.getAttribute('name'),node.get('value'));}});window.location.reload();});target.one('.close').on('click',function(ev){Y.one('#shortcut-help').hide();});}},help:'Display this help',label:'Shift + ?'},'A-e':{callback:function callback(evt){this.fire('navigateTo',{url:'/:gui:/'});},help:'Navigate to the model overview',label:'Alt + e'},'S-+':{fire:'zoom_in',help:'Zoom In',label:'Shift + "+"'},'S--':{fire:'zoom_out',help:'Zoom Out',label:'Shift + -'},'S-0':{fire:'panToCenter',help:'Center the model overview',label:'Shift + 0'},'esc':{fire:'clearState',callback:function callback(){Y.one('#shortcut-help').hide();},help:'Cancel current action',label:'Esc'},'S-d':{callback:function callback(evt){views.utils.exportEnvironmentFile(this.db);},help:'Export the model',label:'Shift + d'},'C-S-d':{callback:function callback(evt){Y.fire('saveWebsocketLog');},help:'Save the websocket log to a file',label:'Control + Shift + s'}},behaviors:{timestamp:{callback:function callback(){Y.later(6000,this,function(o){Y.one('body').all('[data-timestamp]').each(function(node){node.setHTML(views.humanizeTimestamp(node.getAttribute('data-timestamp')));});},[],true);}}},activateHotkeys:function activateHotkeys(){var key_map={'/':191,'?':63,'+':187,'-':189,enter:13,esc:27,backspace:8,tab:9,pageup:33,pagedown:34};var code_map={};Y.each(key_map,function(v,k){code_map[v]=k;});this._keybindings=Y.one(window).on('keydown',function(evt){var tagName=evt.target.tagName;var contentEditable=evt.target.contentEditable;var currentKey;if(code_map[evt.keyCode]){currentKey=code_map[evt.which];}else{currentKey=String.fromCharCode(evt.which).toLowerCase();}if(!tagName){tagName=evt.target.getDOMNode().tagName;}if(!contentEditable){contentEditable=evt.target.getDOMNode().contentEditable;}if(currentKey==='esc'&&evt.target.className==='header-search__input'){evt.target.blur();}else if(['INPUT','TEXTAREA'].indexOf(tagName)!==-1||contentEditable==='true'){return;}var symbolic=[];if(evt.ctrlKey){symbolic.push('C');}if(evt.altKey){symbolic.push('A');}if(evt.shiftKey){symbolic.push('S');}symbolic.push(currentKey);var trigger=symbolic.join('-');var spec=this.keybindings[trigger];if(spec){if(spec.condition&&!spec.condition.call(this)){return;}var target=Y.one(spec.target);if(target){if(spec.toggle){if(target.getStyle('display')!=='none'){target.hide();}else{target.show();}}if(spec.focus){target.focus();}}if(spec.callback){spec.callback.call(this,evt,target);}if(spec.fire){this.views.environment.instance.topo.fire(spec.fire);}evt.stopPropagation();evt.preventDefault();}},this);},initializer:function initializer(cfg){cfg=cfg||{};window.flags=window.flags||{};var consoleEnabled=this.get('consoleEnabled');if(window.mochaPhantomJS===undefined){if(consoleEnabled){consoleManager.native();}else{consoleManager.noop();}}this.cookieHandler=null;this.renderEnvironment=true;this.redirectPath='/';this._routeSeen={};this.dragNotifications=[];this.db=new models.Database();this._setupCharmstore(window.jujulib.charmstore);this._setupBundleservice(window.jujulib.bundleservice);this._setupRomulusServices(window.juju_config,window.jujulib,window.localStorage);this.modelController=new juju.ModelController({db:this.db,charmstore:this.get('charmstore')});var environments=juju.environments;this._setupUIState(cfg.sandbox,cfg.baseUrl);cfg.state=this.state;var env=this.get('env');if(env){this._init(cfg,env,this.get('controllerAPI'));return;}var ecs=new juju.EnvironmentChangeSet({db:this.db});ecs.on('changeSetModified',this._renderDeploymentBar.bind(this));ecs.on('currentCommitFinished',this._renderDeploymentBar.bind(this));var modelOptions={ecs:ecs,user:this.get('user'),password:this.get('password'),conn:this.get('conn'),jujuCoreVersion:this.get('jujuCoreVersion'),bundleService:this.get('bundleService')};var controllerOptions=Object.assign({},modelOptions);if(this.get('sandbox')){modelOptions=this.createSandboxConnection(Object.assign({},modelOptions));controllerOptions=this.createSandboxConnection(Object.assign({},controllerOptions));}else{modelOptions.webHandler=new environments.web.WebHandler();}var modelAPI=void 0,controllerAPI=void 0;if(this.isLegacyJuju()){modelAPI=new environments.GoLegacyEnvironment(modelOptions);}else{modelAPI=new environments.GoEnvironment(modelOptions);controllerAPI=new Y.juju.ControllerAPI(controllerOptions);}this._init(cfg,modelAPI,controllerAPI);},_init:function _init(cfg,modelAPI,controllerAPI){var _this=this;var modelUUID=this.get('modelUUID')||window.juju_config&&window.juju_config.jujuEnvUUID;this.set('modelUUID',modelUUID);var user=modelAPI.get('user');var password=modelAPI.get('password');var macaroons=null;if(!user||!password){var credentials=modelAPI.getCredentials();if(credentials.areAvailable){user=credentials.user;password=credentials.password;macaroons=credentials.macaroons;}}modelAPI.setCredentials({user:user,password:password,macaroons:macaroons});this.env=modelAPI;var getBundleChanges=void 0;if(controllerAPI){this.controllerAPI=this.setUpControllerAPI(controllerAPI,user,password,macaroons);getBundleChanges=this.controllerAPI.getBundleChanges.bind(this.controllerAPI);}else{modelAPI.set('socket_url',this.createSocketURL(this.get('socketTemplate'),modelUUID));getBundleChanges=this.env.getBundleChanges.bind(this.env);}this.modelController.set('env',this.env);var environments=Y.namespace('juju.environments');this.bundleImporter=new Y.juju.BundleImporter({db:this.db,modelAPI:this.env,getBundleChanges:getBundleChanges,fakebackend:new environments.FakeBackend({charmstore:this.get('charmstore')}),isLegacyJuju:this.isLegacyJuju(),hideDragOverNotification:this._hideDragOverNotification.bind(this)});this.acl=new Y.juju.generateAcl(this.controllerAPI,this.env);this.changesUtils=window.juju.utils.ChangesUtils;this.relationUtils=window.juju.utils.RelationUtils;window.onbeforeunload=views.utils.unloadWindow.bind(this);this.on('*:navigateTo',function(e){this.navigate(e.url);},this);this.env.on('permissionDenied',this.onEnvPermissionDenied,this);this.env.after('environmentNameChange',this.onEnvironmentNameChange,this);this.env.after('defaultSeriesChange',this.onDefaultSeriesChange,this);this.env.after('login',this.onLogin,this);var maasServer=this.env.get('maasServer');if(maasServer===undefined){this.env.once('maasServerChange',this._onMaasServer,this);}else{this._displayMaasLink(maasServer);}this.env.on('delta',this.db.onDelta,this.db);this.endpointsController=new juju.EndpointsController({db:this.db,modelController:this.modelController});this.endpointsController.bind();this.location=window.location;this.env.after('connectedChange',function(evt){if(!evt.newVal){return;}_this.env.userIsAuthenticated=false;var credentials=_this.env.getCredentials();if(credentials.areAvailable){_this.loginToAPIs(null,!!credentials.macaroons,[_this.env]);return;}var querystring=_this.location.search.substring(1);var qs=Y.QueryString.parse(querystring);var authtoken=qs.authtoken||'';if(authtoken||authtoken.length){if(Array.isArray(authtoken)){authtoken=authtoken[0];}_this.env.tokenLogin(authtoken);}if(!_this.controllerAPI){_this._displayLogin();}});this.db.on('update',this.on_database_changed,this);this.enableBehaviors();this.db.machines.after(['add','remove','*:change'],this.on_database_changed,this);this.db.services.after(['add','remove','*:change'],this.on_database_changed,this);this.db.relations.after(['add','remove','*:change'],this.on_database_changed,this);this.db.environment.after(['add','remove','*:change'],this.on_database_changed,this);this.db.units.after(['add','remove','*:change'],this.on_database_changed,this);this.db.notifications.after('add',this._renderNotifications,this);Y.on('initiateDeploy',function(charm,ghostAttributes){this.deployService(charm,ghostAttributes);},this);this._boundAppDragOverHandler=this._appDragOverHandler.bind(this);['dragenter','dragover','dragleave'].forEach(function(eventName){document.addEventListener(eventName,_this._boundAppDragOverHandler);});this.once('ready',function(e){if(this.controllerAPI){this.controllerAPI.connect();}else{this.env.connect();}this.dispatch();this.on('*:autoplaceAndCommitAll',this._autoplaceAndCommitAll,this);},this);this.zoomMessageHandler=Y.one(Y.config.win).on('resize',function(e){this._handleZoomMessage();},this);},createSandboxConnection:function createSandboxConnection(cfg){cfg.socket_url=this.get('sandboxSocketURL');var environments=juju.environments;var sandboxModule=environments.sandbox;var fakebackend=new environments.FakeBackend({charmstore:this.get('charmstore')});if(cfg.user&&cfg.password){var credentials=fakebackend.get('authorizedUsers');credentials['user-'+cfg.user]=cfg.password;fakebackend.set('authorizedUsers',credentials);}cfg.conn=new sandboxModule.ClientConnection({juju:new sandboxModule.GoJujuAPI({state:fakebackend,socket_url:cfg.socket_url,bundleService:cfg.bundleService})});cfg.webHandler=new environments.web.WebSandbox({state:fakebackend});return cfg;},setUpControllerAPI:function setUpControllerAPI(controllerAPI,user,password,macaroons){var _this2=this;var external=this._getExternalAuth();controllerAPI.setAttrs({user:user,password:password});controllerAPI.setCredentials({user:user,password:password,macaroons:macaroons,external:external});controllerAPI.after('login',function(evt){if(evt.err){_this2._renderLogin(evt.err);return;}_this2.dispatch();if(_this2.env.get('modelUUID')){return;}var modelUUID=_this2.get('modelUUID')||window.juju_config&&window.juju_config.jujuEnvUUID;if(modelUUID==='disconnected'){_this2.switchEnv();return;}_this2.controllerAPI.listModelsWithInfo(function(err,modelList){if(err){console.error('unable to list models',err);_this2.db.notifications.add({title:'Unable to list models',message:'Unable to list models: '+err,level:'error'});return;}modelList=modelList.filter(function(model){return!model.err;});if(modelList.some(function(data){return data.id===_this2.env.get('modelId');})){return;}var selectedModel=_this2._pickModel(modelList,modelUUID);if(selectedModel===null){console.log('cannot select a model: using unconnected mode');_this2.switchEnv();return;}_this2.switchEnv(_this2.createSocketURL(_this2.get('socketTemplate'),selectedModel.uuid));});});controllerAPI.after('connectedChange',function(evt){if(!evt.newVal){return;}var creds=_this2.controllerAPI.getCredentials();if(!creds.areAvailable&&!_this2.get('gisf')){_this2._displayLogin();return;}if(_this2.get('gisf')||creds.macaroons||creds.areExternal){_this2.loginToAPIs(null,true,[_this2.controllerAPI]);}else{_this2.loginToAPIs(null,false,[_this2.controllerAPI]);}});controllerAPI.set('socket_url',this.createSocketURL(this.get('controllerSocketTemplate')));return controllerAPI;},isLegacyJuju:function isLegacyJuju(){var jujuVersion=this.get('jujuCoreVersion');return views.utils.compareSemver(jujuVersion,'2')===-1;},parseURLState:function parseURLState(req,res,next){this.state.loadRequest(req,'',{dispatch:false});next();},changeState:function changeState(state){this.fire('changeState',state);},loginToAPIs:function loginToAPIs(credentials,useMacaroons){var _this3=this;var apis=arguments.length<=2||arguments[2]===undefined?[this.controllerAPI,this.env]:arguments[2];if(useMacaroons){apis.forEach(function(api){if(api&&api.get('connected')){console.log('logging into '+api.name+' with macaroons');api.loginWithMacaroon(new Y.juju.environments.web.Bakery({webhandler:new Y.juju.environments.web.WebHandler(),interactive:_this3.get('interactiveLogin'),serviceName:'juju',dischargeStore:window.localStorage,dischargeToken:window.juju_config.dischargeToken}),_this3._apiLoginHandler.bind(_this3,api));}});return;}apis.forEach(function(api){if(!api){return;}if(credentials){api.setCredentials(credentials);}if(api.get('connected')){console.log('logging into '+api.name+' with user and password');api.login();}});},_apiLoginHandler:function _apiLoginHandler(api,err){var _this4=this;if(!views.utils.isRedirectError(err)){return;}api.redirectInfo(function(err,servers){if(err){_this4.db.notifications.add({title:'Unable to log into Juju',message:err,level:'error'});return;}var hosts=servers[0];var publicHosts=hosts.filter(function(host){return host.scope==='public';});if(!publicHosts.length){_this4.db.notifications.add({title:'Model connection error',message:'Cannot find a public host for connecting to the model',level:'error'});console.error('no public hosts found: '+JSON.stringify(servers));return;}var publicHost=publicHosts[0];_this4.switchEnv(_this4.createSocketURL(_this4.get('socketTemplate'),_this4.get('modelUUID'),publicHost.value,publicHost.port),null,null,null,true,false);});},_renderLogin:function _renderLogin(err){document.getElementById('loading-message').style.display='none';ReactDOM.render(React.createElement(window.juju.components.Login,{setCredentials:this.env.setCredentials.bind(this.env),isLegacyJuju:this.isLegacyJuju(),loginToAPIs:this.loginToAPIs.bind(this),errorMessage:err}),document.getElementById('login-container'));},_renderLogout:function _renderLogout(){if(this.get('sandbox')){return;}var visible=!this.state.getState('current','sectionC','metadata');var charmstore=this.get('charmstore');var bakery=charmstore.bakery;ReactDOM.render(React.createElement(window.juju.components.Logout,{logout:this.logout.bind(this),clearCookie:bakery.clearCookie.bind(bakery),charmstoreLogoutUrl:charmstore.getLogoutUrl(),getUser:this.getUser.bind(this,'charmstore'),clearUser:this.clearUser.bind(this,'charmstore'),visible:visible}),document.getElementById('profile-link-container'));},_renderUserProfile:function _renderUserProfile(){var charmstore=this.get('charmstore');var utils=views.utils;ReactDOM.render(React.createElement(window.juju.components.UserProfile,{acl:this.acl,addNotification:this.db.notifications.add.bind(this.db.notifications),currentModel:this.get('modelUUID'),listBudgets:this.plans.listBudgets.bind(this.plans),listModelsWithInfo:this.controllerAPI.listModelsWithInfo.bind(this.controllerAPI),changeState:this.changeState.bind(this),destroyModels:this.controllerAPI.destroyModels.bind(this.controllerAPI),getAgreements:this.terms.getAgreements.bind(this.terms),getDiagramURL:charmstore.getDiagramURL.bind(charmstore),gisf:this.get('gisf'),interactiveLogin:this.get('interactiveLogin'),pluralize:utils.pluralize.bind(this),staticURL:window.juju_config.staticURL,storeUser:this.storeUser.bind(this),switchModel:utils.switchModel.bind(this,this.createSocketURL.bind(this,this.get('socketTemplate')),this.switchEnv.bind(this),this.env),user:this._getAuth(),users:Y.clone(this.get('users'),true),charmstore:this.get('charmstore')}),document.getElementById('top-page-container'));this._renderBreadcrumb({showEnvSwitcher:false});},_renderISVProfile:function _renderISVProfile(){if(!window.flags||!window.flags.blues){return;}ReactDOM.render(React.createElement(window.juju.components.ISVProfile,{d3:d3}),document.getElementById('top-page-container'));this._renderBreadcrumb({showEnvSwitcher:false});},_renderAccount:function _renderAccount(){ReactDOM.render(React.createElement(window.juju.components.Account,{acl:this.acl,user:this._getAuth(),users:Y.clone(this.get('users'),true)}),document.getElementById('top-page-container'));},_renderEnvSizeDisplay:function _renderEnvSizeDisplay(){var serviceCount=arguments.length<=0||arguments[0]===undefined?0:arguments[0];var machineCount=arguments.length<=1||arguments[1]===undefined?0:arguments[1];var state=this.state;ReactDOM.render(React.createElement(window.juju.components.EnvSizeDisplay,{changeState:this.changeState.bind(this),getAppState:state.getState.bind(state),machineCount:machineCount,pluralize:views.utils.pluralize.bind(this),serviceCount:serviceCount}),document.getElementById('env-size-display-container'));},_renderHeaderSearch:function _renderHeaderSearch(){var state=this.state;ReactDOM.render(React.createElement(window.juju.components.HeaderSearch,{changeState:this.changeState.bind(this),getAppState:state.getState.bind(state)}),document.getElementById('header-search-container'));},_renderNotifications:function _renderNotifications(e){var notification=null;if(e&&e.details){notification=e.details[0].model.getAttrs();}ReactDOM.render(React.createElement(window.juju.components.NotificationList,{notification:notification}),document.getElementById('notifications-container'));},_renderDeployment:function _renderDeployment(metadata){var env=this.env;var currentChangeSet=env.get('ecs').getCurrentChangeSet();if(Object.keys(currentChangeSet).length===0){this.changeState({sectionC:{component:null,metadata:null}});return;}var changesUtils=this.changesUtils;var controllerAPI=this.controllerAPI;var db=this.db;var services=db.services;var utils=views.utils;this._autoPlaceUnits();var cloud=env.get('providerType');if(cloud){cloud={cloudType:cloud,name:env.get('cloud')};}var credentials=controllerAPI&&controllerAPI.getCredentials();var user=credentials&&credentials.user||undefined;ReactDOM.render(React.createElement(window.juju.components.DeploymentFlow,{acl:this.acl,changesFilterByParent:changesUtils.filterByParent.bind(changesUtils,currentChangeSet),changeState:this.changeState.bind(this),cloud:cloud,credential:env.get('credential'),changes:currentChangeSet,deploy:utils.deploy.bind(utils,this),generateAllChangeDescriptions:changesUtils.generateAllChangeDescriptions.bind(changesUtils,services,db.units),generateCloudCredentialName:utils.generateCloudCredentialName,getCloudCredentials:controllerAPI&&controllerAPI.getCloudCredentials.bind(controllerAPI),getCloudCredentialNames:controllerAPI&&controllerAPI.getCloudCredentialNames.bind(controllerAPI),groupedChanges:changesUtils.getGroupedChanges(currentChangeSet),isLegacyJuju:this.isLegacyJuju(),listBudgets:this.plans.listBudgets.bind(this.plans),listClouds:controllerAPI&&controllerAPI.listClouds.bind(controllerAPI),listPlansForCharm:this.plans.listPlansForCharm.bind(this.plans),modelCommitted:env.get('connected'),modelName:db.environment.get('name'),region:env.get('region'),servicesGetById:services.getById.bind(services),updateCloudCredential:controllerAPI&&controllerAPI.updateCloudCredential.bind(controllerAPI),user:user,withPlans:false}),document.getElementById('deployment-container'));},_renderDeploymentBar:function _renderDeploymentBar(){var env=this.env;var ecs=env.get('ecs');var db=this.db;var services=db.services;var servicesArray=services.toArray();var machines=db.machines.toArray();var units=db.units;var changesUtils=this.changesUtils;ReactDOM.render(React.createElement(window.juju.components.DeploymentBar,{acl:this.acl,changeState:this.changeState.bind(this),currentChangeSet:ecs.getCurrentChangeSet(),generateChangeDescription:changesUtils.generateChangeDescription.bind(changesUtils,services,units),hasEntities:servicesArray.length>0||machines.length>0,modelCommitted:this.env.get('connected'),showInstall:!!this.get('sandbox')}),document.getElementById('deployment-bar-container'));},_renderImportExport:function _renderImportExport(){var env=this.env;var ecs=env.get('ecs');var db=this.db;var services=db.services;var servicesArray=services.toArray();var machines=db.machines.toArray();var utils=views.utils;ReactDOM.render(React.createElement(window.juju.components.ImportExport,{acl:this.acl,changeState:this.changeState.bind(this),currentChangeSet:ecs.getCurrentChangeSet(),exportEnvironmentFile:utils.exportEnvironmentFile.bind(utils,db,env.findFacadeVersion('Application')===null),hasEntities:servicesArray.length>0||machines.length>0,hideDragOverNotification:this._hideDragOverNotification.bind(this),importBundleFile:this.bundleImporter.importBundleFile.bind(this.bundleImporter),renderDragOverNotification:this._renderDragOverNotification.bind(this)}),document.getElementById('import-export-container'));},_renderZoom:function _renderZoom(){ReactDOM.render(React.createElement(window.juju.components.Zoom,{topo:this.views.environment.instance.topo}),document.getElementById('zoom-container'));},_renderAddedServices:function _renderAddedServices(hoveredId){var instance=this.views.environment.instance;if(!instance){return;}var topo=instance.topo;var ServiceModule=topo.modules.ServiceModule;if(this.hoverService){this.hoverService.detach();}this.hoverService=topo.on('hoverService',function(service){this._renderAddedServices(service.id);},this);ServiceModule.deselectNodes();var db=this.db;ReactDOM.render(React.createElement(components.Panel,{instanceName:'inspector-panel',visible:db.services.size()>0},React.createElement(components.AddedServicesList,{services:db.services,hoveredId:hoveredId,updateUnitFlags:db.updateUnitFlags.bind(db),findRelatedServices:db.findRelatedServices.bind(db),findUnrelatedServices:db.findUnrelatedServices.bind(db),getUnitStatusCounts:views.utils.getUnitStatusCounts,hoverService:ServiceModule.hoverService.bind(ServiceModule),panToService:ServiceModule.panToService.bind(ServiceModule),changeState:this.changeState.bind(this)})),document.getElementById('inspector-container'));},_renderInspector:function _renderInspector(metadata){var relationUtils=this.relationUtils;var state=this.state;var utils=views.utils;var topo=this.views.environment.instance.topo;var charmstore=this.get('charmstore');var inspector;var service=this.db.services.getById(metadata.id);var localType=metadata.localType;if(service){topo.modules.ServiceModule.selectService(service.get('id'));var charm=this.db.charms.getById(service.get('charm'));var relatableApplications=relationUtils.getRelatableApplications(this.db,models.getEndpoints(service,this.endpointsController));var ecs=this.env.get('ecs');inspector=React.createElement(components.Inspector,{acl:this.acl,service:service,charm:charm,addNotification:this.db.notifications.add.bind(this.db.notifications),setConfig:this.env.set_config.bind(this.env),envResolved:this.env.resolved.bind(this.env),serviceRelations:relationUtils.getRelationDataForService(this.db,service),addGhostAndEcsUnits:utils.addGhostAndEcsUnits.bind(this,this.db,this.env,service),createMachinesPlaceUnits:utils.createMachinesPlaceUnits.bind(this,this.db,this.env,service),destroyService:utils.destroyService.bind(this,this.db,this.env,service),destroyUnits:utils.destroyUnits.bind(this,this.env),destroyRelations:this.relationUtils.destroyRelations.bind(this,this.db,this.env),relatableApplications:relatableApplications,clearState:utils.clearState.bind(this,topo),createRelation:relationUtils.createRelation.bind(this,this.db,this.env),getYAMLConfig:utils.getYAMLConfig.bind(this),changeState:this.changeState.bind(this),exposeService:this.env.expose.bind(this.env),unexposeService:this.env.unexpose.bind(this.env),unplaceServiceUnits:ecs.unplaceServiceUnits.bind(ecs),getAvailableVersions:charmstore.getAvailableVersions.bind(charmstore),getAvailableEndpoints:relationUtils.getAvailableEndpoints.bind(this,this.endpointsController,this.db,models.getEndpoints),getMacaroon:charmstore.bakery.getMacaroon.bind(charmstore.bakery),addCharm:this.env.addCharm.bind(this.env),displayPlans:utils.compareSemver(this.get('jujuCoreVersion'),'2')>-1,modelUUID:this.get('modelUUID')||'',showActivePlan:this.plans.showActivePlan.bind(this.plans),setCharm:this.env.setCharm.bind(this.env),getCharm:this.env.get_charm.bind(this.env),getUnitStatusCounts:utils.getUnitStatusCounts,updateServiceUnitsDisplayname:this.db.updateServiceUnitsDisplayname.bind(this.db),getServiceById:this.db.services.getById.bind(this.db.services),getServiceByName:this.db.services.getServiceByName.bind(this.db.services),linkify:utils.linkify,appState:state.get('current'),appPreviousState:state.get('previous')});}else if(localType&&metadata.flash&&metadata.flash.file){this._hideDragOverNotification();var localCharmHelpers=juju.localCharmHelpers;inspector=React.createElement(components.LocalInspector,{acl:this.acl,file:metadata.flash.file,localType:localType,services:this.db.services,series:utils.getSeriesList(),uploadLocalCharm:localCharmHelpers.uploadLocalCharm.bind(this,this.env,this.db),upgradeServiceUsingLocalCharm:localCharmHelpers.upgradeServiceUsingLocalCharm.bind(this,this.env,this.db),changeState:this.changeState.bind(this)});}else{this.changeState({sectionA:{component:'applications',metadata:null}});return;}ReactDOM.render(React.createElement(components.Panel,{instanceName:'inspector-panel',visible:true,metadata:metadata},inspector),document.getElementById('inspector-container'));},_renderCharmbrowser:function _renderCharmbrowser(metadata){var state=this.state;var utils=views.utils;var charmstore=this.get('charmstore');marked.setOptions({highlight:function highlight(code,lang){var language=Prism.languages[lang];if(language){return Prism.highlight(code,language);}}});ReactDOM.render(React.createElement(components.Charmbrowser,{acl:this.acl,apiUrl:charmstore.url,charmstoreSearch:charmstore.search.bind(charmstore),displayPlans:!this.isLegacyJuju(),series:utils.getSeriesList(),importBundleYAML:this.bundleImporter.importBundleYAML.bind(this.bundleImporter),getBundleYAML:charmstore.getBundleYAML.bind(charmstore),getEntity:charmstore.getEntity.bind(charmstore),getFile:charmstore.getFile.bind(charmstore),getDiagramURL:charmstore.getDiagramURL.bind(charmstore),listPlansForCharm:this.plans.listPlansForCharm.bind(this.plans),renderMarkdown:marked.bind(this),deployService:this.deployService.bind(this),appState:state.get('current'),changeState:this.changeState.bind(this),utils:utils,staticURL:window.juju_config.staticURL,charmstoreURL:window.juju_config.charmstoreURL,apiVersion:window.jujulib.charmstoreAPIVersion,addNotification:this.db.notifications.add.bind(this.db.notifications),makeEntityModel:Y.juju.makeEntityModel}),document.getElementById('charmbrowser-container'));},_emptySectionApp:function _emptySectionApp(){ReactDOM.unmountComponentAtNode(document.getElementById('login-container'));},_emptySectionA:function _emptySectionA(){if(this.hoverService){this.hoverService.detach();}},emptySectionB:function emptySectionB(){ReactDOM.unmountComponentAtNode(document.getElementById('machine-view'));ReactDOM.unmountComponentAtNode(document.getElementById('top-page-container'));},_emptySectionC:function _emptySectionC(){this._renderBreadcrumb({showEnvSwitcher:true});ReactDOM.unmountComponentAtNode(document.getElementById('charmbrowser-container'));ReactDOM.unmountComponentAtNode(document.getElementById('deployment-container'));},_renderMachineView:function _renderMachineView(metadata){var db=this.db;ReactDOM.render(React.createElement(components.MachineView,{acl:this.acl,addGhostAndEcsUnits:views.utils.addGhostAndEcsUnits.bind(this,this.db,this.env),autoPlaceUnits:this._autoPlaceUnits.bind(this),createMachine:this._createMachine.bind(this),destroyMachines:this.env.destroyMachines.bind(this.env),environmentName:db.environment.get('name'),jujuCoreVersion:this.get('jujuCoreVersion'),machines:db.machines,placeUnit:this.env.placeUnit.bind(this.env),removeUnits:this.env.remove_units.bind(this.env),services:db.services,units:db.units}),document.getElementById('machine-view'));},_renderDragOverNotification:function _renderDragOverNotification(){var showIndicator=arguments.length<=0||arguments[0]===undefined?true:arguments[0];this.views.environment.instance.fadeHelpIndicator(showIndicator);ReactDOM.render(React.createElement(components.ExpandingProgress,null),document.getElementById('drag-over-notification-container'));},_setupUIState:function _setupUIState(sandbox,baseUrl){this.state=new models.UIState({baseUrl:baseUrl||'',dispatchers:{}});var dispatchers=this.state.get('dispatchers');dispatchers.sectionA={applications:this._renderAddedServices.bind(this),inspector:this._renderInspector.bind(this),empty:this._emptySectionA.bind(this)};dispatchers.sectionB={account:this._renderAccount.bind(this),machine:this._renderMachineView.bind(this),profile:this._renderUserProfile.bind(this),isv:this._renderISVProfile.bind(this),empty:this.emptySectionB.bind(this)};dispatchers.sectionC={charmbrowser:this._renderCharmbrowser.bind(this),deploy:this._renderDeployment.bind(this),empty:this._emptySectionC.bind(this)};dispatchers.app={login:this._renderLogin.bind(this,null),deployTarget:views.utils.deployTargetDispatcher.bind(this),empty:this._emptySectionApp.bind(this)};this.state.set('dispatchers',dispatchers);this.on('*:changeState',this._changeState,this);},_changeState:function _changeState(e){var state=e.details[0];var url=this.state.generateUrl(state);this.navigate(url);},_pickModel:function _pickModel(modelList,modelUUID){if(!modelList.length){return null;}var matching=[];if(modelUUID){matching=modelList.filter(function(model){return model.uuid===modelUUID;});}var selectedModel=matching.length?matching[0]:modelList[0];this.set('modelUUID',selectedModel.uuid);return selectedModel;},_setupCharmstore:function _setupCharmstore(Charmstore){if(this.get('charmstore')===undefined){var jujuConfig=window.juju_config;var charmstoreURL='';var existingMacaroons,existingCookie,existingDischargeToken;if(!jujuConfig||!jujuConfig.charmstoreURL){console.error('no juju config for charmstoreURL availble');}else{charmstoreURL=jujuConfig.charmstoreURL;existingMacaroons=jujuConfig.charmstoreMacaroons;existingDischargeToken=jujuConfig.dischargeToken;}var apiVersion=window.jujulib.charmstoreAPIVersion;if(window.flags&&window.flags.gisf){existingCookie='macaroon-storefront';}var bakery=new Y.juju.environments.web.Bakery({webhandler:new Y.juju.environments.web.WebHandler(),interactive:this.get('interactiveLogin'),setCookiePath:''+charmstoreURL+apiVersion+'/set-auth-cookie',staticMacaroonPath:''+charmstoreURL+apiVersion+'/macaroon',existingCookie:existingCookie,serviceName:'charmstore',macaroon:existingMacaroons,dischargeStore:window.localStorage,dischargeToken:existingDischargeToken});this.set('charmstore',new Charmstore(charmstoreURL,bakery));var macaroon=bakery.getMacaroon();if(macaroon){this.get('users')['charmstore']={loading:true};this.storeUser('charmstore',false,true);}}},_setupBundleservice:function _setupBundleservice(Bundleservice){if(this.get('bundleService')===undefined){var jujuConfig=window.juju_config;var bundleServiceURL=jujuConfig&&jujuConfig.bundleServiceURL;if(!jujuConfig||!bundleServiceURL){console.error('no juju config for bundleserviceURL availble');return;}var bundleService=new Bundleservice(bundleServiceURL,new Y.juju.environments.web.WebHandler());this.set('bundleService',bundleService);}},_setupRomulusServices:function _setupRomulusServices(config,jujulib,storage){if(!config){return;}if(this.plans||this.terms){console.error('romulus services are being redefined:',this.plans,this.terms);}var interactive=this.get('interactiveLogin');var webHandler=new Y.juju.environments.web.WebHandler();var bakery=new Y.juju.environments.web.Bakery({serviceName:'plans',macaroon:config.plansMacaroons,webhandler:webHandler,interactive:interactive,cookieStore:storage,dischargeStore:window.localStorage,dischargeToken:config.dischargeToken});this.plans=new window.jujulib.plans(config.plansURL,bakery);var bakery=new Y.juju.environments.web.Bakery({serviceName:'terms',macaroon:config.termsMacaroons,webhandler:webHandler,interactive:interactive,cookieStore:storage,dischargeStore:window.localStorage,dischargeToken:config.dischargeToken});this.terms=new window.jujulib.terms(config.termsURL,bakery);},getEnvDefaultSeries:function getEnvDefaultSeries(){return this.env.get('defaultSeries');},_hideDragOverNotification:function _hideDragOverNotification(){this.views.environment.instance.fadeHelpIndicator(false);ReactDOM.unmountComponentAtNode(document.getElementById('drag-over-notification-container'));},_appDragOverHandler:function _appDragOverHandler(e){e.preventDefault();if(!this._determineFileType(e.dataTransfer)){return;}if(e.type==='dragenter'){this._renderDragOverNotification();}this._dragleaveTimerControl(e.type==='dragover'?'stop':'start');},_dragleaveTimerControl:function _dragleaveTimerControl(action){var _this5=this;if(this._dragLeaveTimer){window.clearTimeout(this._dragLeaveTimer);this._dragLeaveTimer=null;}if(action==='start'){this._dragLeaveTimer=setTimeout(function(){_this5._hideDragOverNotification();},100);}},_determineFileType:function _determineFileType(dataTransfer){var types=dataTransfer.types;var fileFound=Object.keys(types).some(function(key){if(types[key]==='Files'){return true;}});if(!fileFound){return false;}if(dataTransfer.items){var file=dataTransfer.items[0];if(file.type==='application/zip'||file.type==='application/x-zip-compressed'){return'zip';}return'yaml';}return'';},_autoplaceAndCommitAll:function _autoplaceAndCommitAll(){this._autoPlaceUnits();this.env.get('ecs').commit(this.env);},_handleZoomMessage:function _handleZoomMessage(){this._displayZoomMessage(Y.one('body').get('winWidth'),Y.UA.os);},_displayZoomMessage:function _displayZoomMessage(viewportWidth,os){var metaKey=os==='macintosh'?'command':'ctrl';if(!this.zoomMessageDisplayed&&viewportWidth<=1024){this.db.notifications.add({title:'Browser size adjustment',message:'This browser needs to be maximised or zoomed out to'+' display the Juju GUI properly. Try using "'+metaKey+'+-" to zoom the window.',level:'error'});this.zoomMessageDisplayed=true;}},destructor:function destructor(){var _this6=this;if(this.dbChangedTimer){clearTimeout(this.dbChangedTimer);}if(this.zoomMessageHandler){this.zoomMessageHandler.detach();}if(this._keybindings){this._keybindings.detach();}var toBeDestroyed=[this.env,this.controllerAPI,this.db,this.endpointsController];toBeDestroyed.forEach(function(obj){if(obj&&obj.destroy){obj.detachAll();obj.destroy();}});['dragenter','dragover','dragleave'].forEach(function(eventName){document.removeEventListener(eventName,_this6._boundAppDragOverHandler);});},enableBehaviors:function enableBehaviors(){Y.each(this.behaviors,function(behavior){behavior.callback.call(this);},this);},on_database_changed:function on_database_changed(evt){if(this.dbChangedTimer){clearTimeout(this.dbChangedTimer);}this.dbChangedTimer=setTimeout(this._dbChangedHandler.bind(this),100);return;},_dbChangedHandler:function _dbChangedHandler(){if(this.views.environment.instance){this.views.environment.instance.topo.update();}this.dispatch();this._renderComponents();},_displayLogin:function _displayLogin(){this.set('loggedIn',false);var component=this.state.getState('current','app','component');if(!component||component!=='login'){this.state.dispatch({app:{component:'login',metadata:{redirectPath:this.get('currentUrl')}}});}},logout:function logout(req){var _this7=this;var environmentInstance=this.views.environment.instance;if(environmentInstance){environmentInstance.topo.update();}this.set('modelUUID','');this.set('loggedIn',false);var closeController=function closeController(callback){callback();};var controllerAPI=this.controllerAPI;if(controllerAPI){closeController=controllerAPI.close.bind(controllerAPI);}this.env.close(function(){closeController(function(){if(controllerAPI){controllerAPI.connect();}else{_this7.env.connect();}_this7.maskVisibility(true);_this7.env.get('ecs').clear();_this7.db.reset();_this7.db.fire('update');_this7._renderLogin(null);});});},checkUserCredentials:function checkUserCredentials(req,res,next){var apis=[this.env,this.controllerAPI];var shouldDisplayLogin=apis.some(function(api){if(!api||!api.get('connected')){return false;}return!api.userIsAuthenticated;});if(shouldDisplayLogin){this._displayLogin();return;}next();},onEnvPermissionDenied:function onEnvPermissionDenied(evt){this.db.notifications.add(new models.Notification({title:evt.title,message:evt.message,level:'error'}));},popLoginRedirectPath:function popLoginRedirectPath(){var result=this.redirectPath;delete this.redirectPath;var currentPath=this.get('currentUrl');var loginPath=/^\/login(\/|$)/;if(currentPath!=='/'&&!loginPath.test(currentPath)){result=currentPath;}else if(!result||loginPath.test(result)){result='/';}return result;},onLogin:function onLogin(evt){if(evt.err){this._renderLogin(evt.err);return;}this.maskVisibility(false);this._emptySectionApp();this.set('loggedIn',true);if(evt.fromToken){this.env.onceAfter('environmentNameChange',function(){this.db.notifications.add(new models.Notification({title:'Logged in with Token',message:'You have successfully logged in with a '+'single-use authentication token.',level:'important'}));},this);}var querystring=this.location.search.substring(1);var qs=Y.QueryString.parse(querystring);var changesToken=qs.changestoken||'';if(changesToken||changesToken.length){if(Array.isArray(changesToken)){changesToken=changesToken[0];}this.bundleImporter.importChangesToken(changesToken);}if(!this.get('gisf')){var redirectPath=this.popLoginRedirectPath();this.navigate(redirectPath,{overrideAllNamespaces:true});}},createSocketURL:function createSocketURL(template,uuid,server,port){var baseUrl='';var sandbox=this.get('sandbox');if(template[0]==='/'||sandbox){var schema=this.get('socket_protocol')||'wss';baseUrl=schema+'://'+window.location.hostname;if(window.location.port!==''){baseUrl+=':'+window.location.port;}if(sandbox){if(template===this.get('controllerSocketTemplate')){return baseUrl+'/sandbox-controller';}return baseUrl+'/sandbox';}}var defaults=this.get('apiAddress').replace('wss://','').split(':');template=template.replace('$uuid',uuid);template=template.replace('$server',server||defaults[0]);template=template.replace('$port',port||defaults[1]);return baseUrl+template;},switchEnv:function switchEnv(socketUrl,username,password,callback){var reconnect=arguments.length<=4||arguments[4]===undefined?!!socketUrl:arguments[4];var clearDB=arguments.length<=5||arguments[5]===undefined?true:arguments[5];if(this.get('sandbox')){console.log('switching models is not supported in sandbox');}console.log('switching model connection');if(username&&password){this.env.setCredentials({user:username,password:password});};var credentials=this.env.getCredentials();if(callback){var onLogin=function onLogin(callback){callback(this.env);};this.env.onceAfter('login',onLogin.bind(this,callback),this);}if(clearDB){this.env.get('ecs').clear();}var setUpModel=function setUpModel(model){model.set('socket_url',socketUrl);model.setCredentials(credentials);if(reconnect){model.connect();}};var onclose=function(){this.on_close();setUpModel(this);}.bind(this.env);if(this.env.ws){this.env.ws.onclose=onclose;this.env.close();if(!this.env.get('connected')){setUpModel(this.env);}}else{this.env.close(onclose);}this.hideConnectingMask();if(clearDB){this.db.reset();this.db.fire('update');}var instance=this.views.environment.instance;if(instance){instance.topo.modules.ServiceModule.centerOnLoad=true;}},_onMaasServer:function _onMaasServer(evt){this._displayMaasLink(evt.newVal);},_displayMaasLink:function _displayMaasLink(maasServer){if(maasServer===null){return;}var maasContainer=Y.one('#maas-server');maasContainer.one('a').set('href',maasServer);maasContainer.show();},maskVisibility:function maskVisibility(){var visibility=arguments.length<=0||arguments[0]===undefined?true:arguments[0];var mask=document.getElementById('full-screen-mask');var display=visibility?'block':'none';if(mask){mask.style.display=display;}},showConnectingMask:function showConnectingMask(){this.maskVisibility(true);var msg=document.getElementById('loading-message');if(msg){msg.style.display='block';}},hideConnectingMask:function hideConnectingMask(){this.maskVisibility(false);var msg=document.getElementById('loading-message');if(msg){msg.style.display='none';}},onDefaultSeriesChange:function onDefaultSeriesChange(evt){this.db.environment.set('defaultSeries',evt.newVal);},onEnvironmentNameChange:function onEnvironmentNameChange(evt){var environmentName=evt.newVal||'untitled-model';this.db.environment.set('name',environmentName);this._renderBreadcrumb();document.title=environmentName+' - Juju GUI';},_renderComponents:function _renderComponents(){this._renderEnvSizeDisplay(this.db.services.size(),this.db.machines.filterByParent().length);this._renderDeploymentBar();this._renderImportExport();this._renderZoom();this._renderBreadcrumb();this._renderHeaderSearch();this.state.dispatch();},show_environment:function show_environment(req,res,next){if(!this.renderEnvironment){next();return;}var options={getModelURL:Y.bind(this.getModelURL,this),nsRouter:this.nsRouter,endpointsController:this.endpointsController,useDragDropImport:this.get('sandbox'),db:this.db,env:this.env,ecs:this.env.ecs,charmstore:this.get('charmstore'),bundleImporter:this.bundleImporter,staticURL:window.juju_config.staticURL};this.showView('environment',options,{callback:function callback(){var envView=this.views.environment.instance;envView.rendered();},render:true});if(!this.env.get('environmentName')){this.env.set('environmentName',null);}this._renderComponents();this._renderNotifications();this._renderLogout();this._handleZoomMessage();next();},getModelURL:function getModelURL(model,intent){var matches=[],attrs=model instanceof Y.Model?model.getAttrs():model,routes=this.get('routes'),regexPathParam=/([:*])([\w\-]+)?/g,idx=0,finalPath='';routes.forEach(function(route){var path=route.path,required_model=route.model,reverse_map=route.reverse_map;if(path==='*'||required_model===undefined||model.name!==required_model){return;}path=path.replace(regexPathParam,function(match,operator,key){if(reverse_map!==undefined&&reverse_map[key]){key=reverse_map[key];}return attrs[key];});matches.push(Y.mix({path:path,route:route,attrs:attrs,intent:route.intent,namespace:route.namespace}));});matches=matches.filter(function(match){return match.intent===intent;});if(matches.length>1){console.warn('Ambiguous routeModel',attrs.id,matches);idx=matches.length-1;}if(matches[idx]&&matches[idx].path){finalPath=this.nsRouter.url({gui:matches[idx].path});}return finalPath;},authorizeCookieUse:function authorizeCookieUse(req,res,next){var GTM_enabled=this.get('GTM_enabled');if(GTM_enabled){this.cookieHandler=this.cookieHandler||new Y.juju.Cookies();this.cookieHandler.check();}next();},getUser:function getUser(service){return this.get('users')[service];},clearUser:function clearUser(service){delete this.get('users')[service];},storeUser:function storeUser(service,rerenderProfile,rerenderBreadcrumb){var callback=function callback(error,auth){if(error){console.error('Unable to query user information',error);return;}if(auth){this.get('users')[service]=auth;if(rerenderProfile){this._renderUserProfile();}}if(rerenderBreadcrumb){this._renderBreadcrumb();}};if(service==='charmstore'){this.get('charmstore').whoami(callback.bind(this));}else{console.error('Unrecognized service',service);}},_getAuth:function _getAuth(){var external=this._getExternalAuth();if(external){return external;}var users=this.get('users');var user;if(users){var controllerUser;if(this.env){var credentials=this.env.getCredentials();if(credentials.user){controllerUser={user:credentials.user};}}user=controllerUser||users.charmstore;if(user&&user.user){user.usernameDisplay=user.user;}}return user;},_getExternalAuth:function _getExternalAuth(){var externalAuth=this.get('auth');if(externalAuth&&externalAuth.user){externalAuth.usernameDisplay=externalAuth.user.name;}return externalAuth;}},{ATTRS:{html5:true,charmworldURL:{},loggedIn:{value:false},currentUrl:{getter:function getter(){var nsRouter=this.nsRouter;var routes=nsRouter.parse(this.location.toString());if(routes.search){var qs=Y.QueryString.parse(routes.search);['authtoken','changestoken'].forEach(function(token){if(Y.Lang.isValue(qs[token])){delete qs[token];}});routes.search=Y.QueryString.stringify(qs);}return nsRouter.url(routes);}},charmstore:{},interactiveLogin:{value:true},apiAddress:{value:''},socketTemplate:{value:'/model/$uuid/api'},users:{value:{}},routes:{value:[{path:'*',callbacks:'parseURLState'},{path:'*',callbacks:'checkUserCredentials'},{path:'*',callbacks:'show_environment'},{path:'*',callbacks:'authorizeCookieUse'}]}}});Y.namespace('juju').App=JujuGUI;},'0.5.3',{requires:['acl','changes-utils','juju-app-state','juju-charm-models','juju-bundle-models','juju-controller-api','juju-endpoints-controller','juju-env-bakery','juju-env-base','juju-env-fakebackend','juju-env-api','juju-env-legacy-api','juju-env-sandbox','juju-env-web-handler','juju-env-web-sandbox','juju-models','jujulib-utils','net-utils','ns-routing-app-extension','account','added-services-list','charmbrowser-component','deployment-bar','deployment-flow','env-size-display','header-breadcrumb','import-export','expanding-progress','header-search','inspector-component','isv-profile','local-inspector','machine-view','login-component','logout-component','notification-list','panel-component','shortcuts','user-profile','zoom','d3-components','juju-view-utils','juju-topology','juju-view-environment','juju-landscape','autodeploy-extension','io','json-parse','app-base','app-transitions','base','bundle-importer','bundle-import-notifications','event-tracker','node','model','app-cookies-extension','app-renderer-extension','cookie','querystring','event-key','event-touch','model-controller','FileSaver','ghost-deployer-extension','local-charm-import-helpers','environment-change-set','relation-utils']});