'use strict';YUI.add('relation-utils',function(Y){var RelationUtils={};var generateHash=function generateHash(value){return value.split('').reduce(function(hash,character){hash=(hash<<5)-hash+character.charCodeAt(0);return hash&hash;},0);};RelationUtils.generateHash=generateHash;var generateSafeDOMId=function generateSafeDOMId(value,parentId){parentId=parentId||'';return'e-'+value.replace(/\W/g,'_')+'-'+generateHash(value+parentId);};RelationUtils.generateSafeDOMId=generateSafeDOMId;RelationUtils.isPythonRelation=function(relationId){var regex=/^relation-\d+$/;return regex.test(relationId);};RelationUtils.getRelationDataForService=function(db,application,withApplication){var relationsArray=db.relations.get_relations_for_service(application);if(withApplication!==undefined){var withApplicationName=withApplication.get('id');relationsArray=relationsArray.filter(function(relation){var rel=relation.getAttrs();if(rel.endpoints[0][0]===withApplicationName||rel.endpoints[1][0]===withApplicationName){return relation;}});}var applicationName=application.get('id');return relationsArray.map(function(relation){var rel=relation.getAttrs(),near,far;if(rel.endpoints[0][0]===applicationName){near=rel.endpoints[0];far=rel.endpoints[1];}else{near=rel.endpoints[1];far=rel.endpoints[0];}rel.near={service:near[0],serviceName:application.get('name'),role:near[1].role,name:near[1].name};var farService;if(far){var id=far[0];var _application=db.services.getById(id);if(_application){farService={service:id,serviceName:_application.get('name'),role:far[1].role,name:far[1].name};}}rel.far=farService;var relationId=rel.relation_id;if(RelationUtils.isPythonRelation(relationId)){var relNumber=relationId.split('-')[1];rel.ident=near[1].name+':'+parseInt(relNumber,10);}else{rel.ident=relationId;}rel.elementId=generateSafeDOMId(rel.relation_id);return rel;});};RelationUtils.parseEndpointStrings=function(db,endpoints){return endpoints.map(function(endpoint){var epData=endpoint.split(':');var result={};if(epData.length>1){result.name=epData[0];result.type=epData[1];}else{result.name=epData[0];}result.service=db.services.getById(result.name);if(result.service){result.charm=db.charms.getById(result.service.get('charm'));if(!result.charm){console.warn('Failed to load charm',result.charm,db.charms.size(),db.charms.get('id'));}}else{console.warn('failed to resolve service',result.name);}return result;},this);};RelationUtils.findEndpointMatch=function(endpoints){var matches=[],result;[0,1].forEach(function(providedIndex){var providingEndpoint=endpoints[providedIndex];var provides=Object.assign({},providingEndpoint.charm.get('provides')),requiringEndpoint=endpoints[!providedIndex+0],requires=Object.assign({},requiringEndpoint.charm.get('requires'));if(!provides['juju-info']){provides['juju-info']={'interface':'juju-info',scope:'container'};}var candidateProvideTypes,candidateRequireTypes;if(providingEndpoint.type){candidateProvideTypes=[providingEndpoint.type];}else{candidateProvideTypes=Object.keys(provides);}if(requiringEndpoint.type){candidateRequireTypes=[requiringEndpoint.type];}else{candidateRequireTypes=Object.keys(requires);}candidateProvideTypes.forEach(function(provideType){candidateRequireTypes.forEach(function(requireType){var provideMatch=provides[provideType],requireMatch=requires[requireType];if(provideMatch&&requireMatch&&provideMatch['interface']===requireMatch['interface']){matches.push({'interface':provideMatch['interface'],scope:provideMatch.scope||requireMatch.scope,provides:providingEndpoint,requires:requiringEndpoint,provideType:provideType,requireType:requireType});}});});});if(matches.length===0){var message='Specified relation is unavailable.';console.error(message,endpoints);result={error:message};}else if(matches.length>1){var explicitRelations=matches.filter(function(rel){return rel['provideType']!=='juju-info';});if(explicitRelations.length===0){var _message='No explicitly specified relations are available.';console.error(_message,endpoints);result={error:_message};}else if(explicitRelations.length>1){result={error:'Ambiguous relationship is not allowed.'};}else{result=explicitRelations[0];}}else{result=matches[0];result.provides=Object.assign({},result.provides);result.requires=Object.assign({},result.requires);result.provides.type=result.provideType;result.requires.type=result.requireType;}return result;};RelationUtils.DecoratedRelation=function(relation,source,target){var endpoints=relation.endpoints||relation.get('endpoints');var hasRelations=!!endpoints;var decorated={source:source,target:target,sourceId:hasRelations?endpoints[0][0]+':'+endpoints[0][1].name:'',targetId:hasRelations?endpoints[1][0]+':'+endpoints[1][1].name:'',compositeId:source.modelId+(hasRelations?':'+endpoints[0][1].name:'')+'-'+target.modelId+(hasRelations?':'+endpoints[1][1].name:'')};decorated._endpointHasError=function(service){var endpoint=this.endpoints[0][0]===service.id?this.endpoints[0]:this.endpoints[1];return service.units.toArray().some(function(unit){var relationName=endpoint[1].name+'-'+'relation',relationError=false,agentStateData=unit.agent_state_data,agentStateInfo=unit.agent_state_info;if(agentStateData&&agentStateData.hook){relationError=agentStateData.hook.indexOf(relationName)===0;}if(!relationError&&agentStateInfo){relationError=agentStateInfo.indexOf(relationName)>=0;}return unit.agent_state==='error'&&relationError;});};decorated.sourceHasError=function(){return this._endpointHasError(this.source);};decorated.targetHasError=function(){return this._endpointHasError(this.target);};decorated.hasRelationError=function(){return this.sourceHasError()||this.targetHasError();};Object.assign(decorated,relation.getAttrs());decorated.isSubordinate=RelationUtils.isSubordinateRelation(decorated);return decorated;};RelationUtils.isSubordinateRelation=function(relation){var source=relation.source,target=relation.target,subordinateModel=true;if(target&&source){subordinateModel=target.model.get('subordinate')||source.model.get('subordinate');}return subordinateModel&&relation.scope==='container';};var _relationCollection={};Object.defineProperties(_relationCollection,{aggregatedStatus:{get:function get(){var pending=this.relations.some(function(relation){return relation.pending;});if(pending){return'pending';}var unhealthy=this.relations.some(function(relation){return relation.hasRelationError();});var pendingDeletion=this.relations.some(function(relation){return relation.deleted;});if(unhealthy){return(pendingDeletion?'pending-':'')+'error';}if(this.isSubordinate){return'subordinate';}else{return(pendingDeletion?'pending-':'')+'healthy';}}},isSubordinate:{get:function get(){return this.relations.every(function(relation){return relation.isSubordinate;});}}});function RelationCollection(source,target,relations){var collection=Object.create(_relationCollection);collection.source=source;collection.target=target;collection.relations=relations;collection.id=relations[0].id;collection.compositeId=relations[0].id;return collection;}RelationUtils.RelationCollection=RelationCollection;RelationUtils.toRelationCollections=function(relations){var collections={};relations.forEach(function(relation){var key=[relation.source.modelId,relation.target.modelId].sort().join();if(collections[key]){collections[key].relations.push(relation);}else{collections[key]=new RelationCollection(relation.source,relation.target,[relation]);}});return Object.keys(collections).map(function(key){return collections[key];});};RelationUtils.destroyRelations=function(db,env,relations,callback){relations.forEach(function(relationId){var relation=db.relations.getById(relationId);var endpoints=relation.get('endpoints');env.remove_relation(endpoints[0],endpoints[1],callback);});};RelationUtils.createRelation=function(db,env,endpoints,callback){var endpointData=RelationUtils.parseEndpointStrings(db,[endpoints[0][0],endpoints[1][0]]);var match=RelationUtils.findEndpointMatch(endpointData);var relationId='pending-'+endpoints[0][0]+':'+endpoints[0][1].name+(endpoints[1][0]+':'+endpoints[1][1].name);var service1=endpointData[0].service;var service2=endpointData[1].service;var subordinate=void 0;var application=void 0;if(service1.get('subordinate')){subordinate=service1;application=service2;}else if(service2.get('subordinate')){subordinate=service2;application=service1;}if(subordinate){var appSeries=application.get('series');if(subordinate.get('series')!==appSeries){var existingRelations=RelationUtils.getRelationDataForService(db,subordinate);if(existingRelations.length===0){subordinate.set('series',appSeries);}else{db.notifications.add({title:'Subordinate series does not match',message:'Subordinates can only be related to applications with '+'the same series. This subordinate already has a relation to an'+' application with a different series.',level:'error'});return;}}}db.relations.add({relation_id:relationId,'interface':match.interface,endpoints:endpoints,pending:true,scope:match.scope||'global',display_name:'pending'});env.add_relation(endpoints[0],endpoints[1],function(e){db.relations.remove(db.relations.getById(relationId));db.relations.create({relation_id:e.result.id,type:e.result['interface'],endpoints:endpoints,pending:false,scope:e.result.scope});}.bind(this));};RelationUtils.getAvailableEndpoints=function(endpointsController,db,getEndpoints,applicationFrom,applicationTo){var relatableEndpoints=getEndpoints(applicationFrom,endpointsController)[applicationTo.get('id')];var existing=RelationUtils.getRelationDataForService(db,applicationTo,applicationFrom);if(existing.length===0){return relatableEndpoints;}var availableEndpoints=relatableEndpoints.filter(function(relation){return!existing.some(function(existingRelation){return relation[0].name===existingRelation.far.name||relation[1].name===existingRelation.near.name;});});return availableEndpoints;};RelationUtils.getRelatableApplications=function(db,endpoints){return Object.keys(endpoints).map(function(appName){return db.services.getById(appName);});};window.juju.utils.RelationUtils=RelationUtils;},'0.0.1',{requires:[]});